"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("util");
var fs = require("fs");
var path = require("path");
var os = require("os");
var artifactory_service_1 = require("./artifactory-service");
var readdir = util_1.promisify(fs.readdir);
exports.default = {
    tmpDir: path.join(os.homedir(), '.npmfrog', 'package-cache'),
    // tslint:disable-next-line:typedef
    fillCacheFromDisc: function () {
        return __awaiter(this, void 0, void 0, function () {
            var promises, scopes, _loop_1, this_1, _i, scopes_1, scope;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        promises = [];
                        return [4 /*yield*/, readdir(this.tmpDir)];
                    case 1:
                        scopes = _a.sent();
                        _loop_1 = function (scope) {
                            var packages, _loop_2, _i, packages_1, packageName;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, readdir(path.join(this_1.tmpDir, scope))];
                                    case 1:
                                        packages = _a.sent();
                                        _loop_2 = function (packageName) {
                                            var versions, _loop_3, _i, versions_1, version;
                                            return __generator(this, function (_a) {
                                                switch (_a.label) {
                                                    case 0: return [4 /*yield*/, readdir(path.join(this_1.tmpDir, scope, packageName))];
                                                    case 1:
                                                        versions = _a.sent();
                                                        _loop_3 = function (version) {
                                                            artifactory_service_1.default
                                                                .getPackageDetail({ scope: scope, packageName: packageName, version: version })
                                                                .then(function () {
                                                                console.log("caching " + scope + "/" + packageName + "@" + version + " from disc");
                                                            })
                                                                .catch(function () {
                                                                console.warn(scope + "/" + packageName + "@" + version + " on disc seems to be outdated. Is will not be cached.");
                                                            });
                                                        };
                                                        for (_i = 0, versions_1 = versions; _i < versions_1.length; _i++) {
                                                            version = versions_1[_i];
                                                            _loop_3(version);
                                                        }
                                                        return [2 /*return*/];
                                                }
                                            });
                                        };
                                        _i = 0, packages_1 = packages;
                                        _a.label = 2;
                                    case 2:
                                        if (!(_i < packages_1.length)) return [3 /*break*/, 5];
                                        packageName = packages_1[_i];
                                        return [5 /*yield**/, _loop_2(packageName)];
                                    case 3:
                                        _a.sent();
                                        _a.label = 4;
                                    case 4:
                                        _i++;
                                        return [3 /*break*/, 2];
                                    case 5: return [2 /*return*/];
                                }
                            });
                        };
                        this_1 = this;
                        _i = 0, scopes_1 = scopes;
                        _a.label = 2;
                    case 2:
                        if (!(_i < scopes_1.length)) return [3 /*break*/, 5];
                        scope = scopes_1[_i];
                        return [5 /*yield**/, _loop_1(scope)];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        _i++;
                        return [3 /*break*/, 2];
                    case 5: return [2 /*return*/];
                }
            });
        });
    },
};
